// car object for xrally
// (C) 2/2000 Christian Perle (POVaddict)
// render size: 64x64

#include "colors.inc"

#declare BLUECAR=mod(clock,2)
#declare CRot=div(clock,90)

camera {
  location <0, 8, -8>
  up y
  right x
  direction 2*z
  look_at 0
}

light_source {
  <0, 500, -500> White
  area_light 60*x, 60*y, 8, 8
  adaptive 1 jitter
}
light_source {
  <0, 500, 500> White
  area_light 60*x, 60*y, 8, 8
  adaptive 1 jitter
}

#declare Tyre = difference {
  cylinder { <0, 0, 0>, <1, 0, 0>, 1.4 }
  cone {
    <.5, 0, 0>, 1
    <1.1, 0, 0>, 1.3
  }
}

#declare Car = union {
  difference {  // Car body
    box { <-1, 0, -2>, <1, 1, 2> }
    cylinder { <-1.1, 5.2, -1.5>, <1.1, 5.2, -1.5>, 5 }
    pigment {
      bozo
      scale <.25, .25, .5>
      color_map {
      #if (BLUECAR=1)
        [0 color Blue]
        [1 color rgb<.5, .7, 1>]
      #else
        [0 color Red]
        [1 color rgb<1, .7, .5>]
      #end
      }
    }
  }
  union {  // Tyres
    object { Tyre scale .4 translate <1, 0, -.9> }
    object { Tyre scale .4 translate <1, 0, .9> }
    object { Tyre scale .4 rotate 180*y translate <-1, 0, -.9> }
    object { Tyre scale .4 rotate 180*y translate <-1, 0, .9> }
    pigment { Gray30 }
    finish { phong .7 phong_size 10 }
  }
  sphere {  // Windshield
    <0, 0, 0>, 1
    scale <.8, .2, 1.2>
    rotate -20*x
    translate 0.5*y
    pigment { color blue .1 }
    finish { phong 1 reflection .2 }
  }
  union {  // Lights
    box { <-.95, .05, -2.05>, <-.65, .15, -2> }
    box { <.65, .05, -2.05>, <.95, .15, -2> }
    pigment { Yellow }
    finish { ambient .5 }
  }
  union {
    box { <-.95, .2, 2>, <-.8, .8, 2.05> }
    box { <.8, .2, 2>, <.95, .8, 2.05> }
    pigment { Red }
    finish { ambient .5 }
  }
}

object { Car rotate 90*CRot*y translate 1.4*0.4*y  }

plane { y, 0 pigment { Gray50 } }
